/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.analytics.message.sender.model.listener;

import com.liferay.portal.kernel.model.BaseModel;
import com.liferay.portal.kernel.model.User;

import java.util.List;

import org.osgi.annotation.versioning.ProviderType;

/**
 * @author Rachael Koestartyo
 */
@ProviderType
public interface EntityModelListener<T extends BaseModel<T>> {

	public void addAnalyticsMessage(
		String eventType, List<String> includeAttributeNames, T model);

	/**
	 * @deprecated As of Athanasius (7.3.x), replaced by {@link #getAttributeNames(long)}
	 */
	@Deprecated
	public default List<String> getAttributeNames() {
		return null;
	}

	public List<String> getAttributeNames(long companyId);

	public long[] getMembershipIds(User user) throws Exception;

	public String getModelClassName();

	/**
	 * @deprecated As of Athanasius (7.3.x), replaced by {@link #syncAll(long)}
	 */
	@Deprecated
	public default void syncAll() throws Exception {
	}

	public void syncAll(long companyId) throws Exception;

}